// nécessite utils.js, projet_env.js, projet_data.js

//......................................................................................................
//______________________________________________________________________________________________________
// Partie Chargement : cette partie concerne le chargement des images (environnement de l'application et images du TP)
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// retourne le nombre total d'images maximum à charger
// dans l'application. il peut être inférieur en cas de doublons
//___________________________________________________
let resizing = false;
let currentVarTriple = null;
let connections = [];

const defaultWindowSize = 200;
let windowLocation = 0;

window.addEventListener('mouseup', function () {
	if (resizing) resizing = false;
});

window.addEventListener('touchend', function () {
	if (resizing) resizing = false;
});

projet.imageCount = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.imageCount';
	var total = 0;
	if (this.nbTotalImages == 'undefined') {
		var nbimg = taille(this.imageIds);
		log(currentFunctionName, "() ==> nombre d'images déclarés dans projet.imageIds=" + nbimg);
		for (var z in this.zones) {
			if (this.zones[z].imagesCles.length > 0) {
				total += this.zones[z].imagesCles.length;
				if (this.zones[z].zoom.autorise) total += this.zones[z].imagesCles.length;
			} else {
				total += nbimg;
				if (this.zones[z].zoom.autorise) total += nbimg;
			}
		}
		this.nbTotalImages = total;
		log(currentFunctionName, '() ==> ' + total);
	} else total = this.nbTotalImages;
	return total;
};
//___________________________________________________
// chargement des icones de l'interface utilisateur
//___________________________________________________
projet.loadIcons = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.loadIcons';
	log(currentFunctionName, '()');
	this.loadIcon('up');
	this.loadIcon('down');
	this.loadIcon('left');
	this.loadIcon('right');
	this.loadIcon('zoomplus');
	this.loadIcon('zoommoins');
};
//___________________________________________________
// chargement des 2 icones on/off pour l'action passée en paramètre
//___________________________________________________
projet.loadIcon = function (nom) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.loadIcon';
	log(currentFunctionName, '(nom=' + nom + ')');
	this.icones[nom].imgon = new Image();
	this.icones[nom].imgon.src = this.icones[nom].on;
	this.icones[nom].imgoff = new Image();
	this.icones[nom].imgoff.src = this.icones[nom].off;
};

//___________________________________________________
// Préchargement des images avec placement dans les "zones" du "projet"
//___________________________________________________
projet.loadImages = function (progressFunction, callbackFunction) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.loadImages';
	log(currentFunctionName, '(progressFunction=xxx, callbackFunction=xxx)');
	this.loadIcons();
	var loadedImages = 0;
	var nbTotalImages = this.imageCount();
	log(currentFunctionName, this.imageCount());
	for (var zon in this.zones) {
		var filter = false;
		if (this.zones[zon].imagesCles.length > 0)
			// Teste si la zone contient toutes les images ou non
			filter = true;
		for (var src in this.imageIds) {
			var found = false;
			for (var i in this.zones[zon].imagesCles) {
				//Recherche dans le tableau imagesCles si l'id de l'image est présent
				if (this.zones[zon].imagesCles[i] == src) found = true;
			}
			if (!filter || found) {
				//Ne charge l'image courante que si le fichier est sencé être présent
				this.zones[zon].images[src] = new Image();
				this.zones[zon].images[src].onload = function () {
					if (++loadedImages >= nbTotalImages) callbackFunction();
					progressFunction();
				};
				this.zones[zon].images[src].onerror = function () {
					++loadedImages;
					progressFunction();
					if (loadedImages >= nbTotalImages) callbackFunction();
				};
				log(currentFunctionName, '(------) [image=' + 'data/' + zon + '/' + this.imageIds[src] + '.jpg');
				this.zones[zon].images[src].src = 'data/' + zon + '/' + this.imageIds[src] + '.jpg';
				if (this.zones[zon].zoom.autorise) {
					// Idem chargement des images zoom
					this.zones[zon].zoom.images[src] = new Image();
					this.zones[zon].zoom.images[src].onload = function () {
						if (++loadedImages >= nbTotalImages) callbackFunction();
						progressFunction();
					};
					this.zones[zon].zoom.images[src].onerror = function () {
						++loadedImages;
						progressFunction();
						if (loadedImages >= nbTotalImages) callbackFunction();
					};
					this.zones[zon].zoom.images[src].src = 'data/' + zon + '/zoom/' + this.imageIds[src] + '.jpg';
				}
			}
		}
	}
};

//___________________________________________________
// Suppression en mémoire des objets images non trouvées sur le disque
// A appeler dans le callback de l'appel au preload
//___________________________________________________
projet.garbageImages = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.garbageImages';
	log(currentFunctionName, '()');
	for (var zon in this.zones) {
		for (var id in projet.zones[zon].images) {
			if (projet.zones[zon].images[id].width == 0) delete projet.zones[zon].images[id];
		}
		for (var id in projet.zones[zon].zoom.images) {
			if (projet.zones[zon].zoom.images[id].width == 0) delete projet.zones[zon].zoom.images[id];
		}
	}
};

//......................................................................................................
//______________________________________________________________________________________________________
//
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// Retourne true si la zone est active
// (accepte un clic ou action toucher) false sinon
//___________________________________________________
projet.isActive = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.isActive';
	if (this.zones[zon] == null) {
		log(currentFunctionName, '(zon = ' + zon + ') [ZONE nulle] ==> false');
		return false;
	}
	log(currentFunctionName, '(zon = ' + zon + ') ==> ' + this.zones[zon].active);
	return this.zones[zon].active;
};

//___________________________________________________
// Retourne true si la zone est réactive
// (est modifiée par une action sur une autre zone) false sinon
//___________________________________________________
projet.isReactive = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.isReactive';
	if (this.zones[zon] == null) {
		log(currentFunctionName, '(zon = ' + zon + ') [ZONE nulle] ==> false');
		return false;
	}
	log(currentFunctionName, '(zon=' + zon + ') ==> ' + this.zones[zon].reactive);
	return this.zones[zon].reactive;
};

//___________________________________________________
// Action liée à l'évènement "zone active visible" du menu
// Bascule l'affichage des zones actives et réactives sur les différentes fenêtres
//___________________________________________________
projet.toggleViewZones = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.toggleViewZones';
	log(currentFunctionName, '()');
	this.voirZones = !this.voirZones;
	this.afficheImages();
	this.drawZonesActives();
	document.querySelector('#mnuZoneActive').classList.toggle('on');
	document.querySelector('#mnuZoneActive').classList.toggle('off');
};

//___________________________________________________
//Action liée à l'évènement "zoom xxx visible" du menu
//Bascule l'affichage de la fenêtre de zoom liée à une zone donnée
//___________________________________________________
projet.toggleVar = function (varId) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.toggleVar';
	document.querySelector('#mnuEnv_' + varId).classList.toggle('on');
	document.querySelector('#mnuEnv_' + varId).classList.toggle('off');

	const elem = document.querySelector('#var_' + varId);
	if (elem.hasAttribute('initialized')) {
		elem.removeAttribute('initialized');
		elem.style.left = windowLocation + 'px';
		elem.style.top = document.querySelector(`#zoomsDiv`).getBoundingClientRect().y + windowLocation + 'px';
		windowLocation += 30;
		projet.switchZIndex(elem);
	}

	elem.classList.toggle('hide');
	this.variables[varId].visible = !this.variables[varId].visible;
	//	if (this.variables[varId].visible) this.afficheImage (this.getCurrentImageId(zon),zon);
	log(currentFunctionName, '(varId=' + varId + ') [' + varId + '.visible=' + this.variables[varId].visible + ']');
};

//___________________________________________________
//Action liée à l'évènement "zoom xxx visible" du menu
//Bascule l'affichage de la fenêtre de zoom liée à une zone donnée
//___________________________________________________
projet.toggleZoom = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.toggleZoom';
	document.querySelector('#mnuZoom_' + zon).classList.toggle('on');
	document.querySelector('#mnuZoom_' + zon).classList.toggle('off');
	let elem = document.querySelector('#' + this.zones[zon].zoom.id);
	if (elem.hasAttribute('initialized')) {
		elem.removeAttribute('initialized');
		elem.style.left = windowLocation + 'px';
		elem.style.top = document.querySelector(`#zoomsDiv`).getBoundingClientRect().y + windowLocation + 'px';
		windowLocation += 30;
		projet.switchZIndex(elem);
	}
	elem.classList.toggle('hide');
	this.zones[zon].zoom.visible = !this.zones[zon].zoom.visible;
	if (this.zones[zon].zoom.visible) this.afficheImage(this.getCurrentImageId(zon), zon);
	log(currentFunctionName, '(zon=' + zon + ') [' + zon + '.zoom.visible=' + this.zones[zon].zoom.visible + ']');
};

//___________________________________________________
// Bascule Affichage/Masquage des sliders et bouton de zoom
//___________________________________________________
projet.toggleZoomSliders = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.toggleZoomSliders';
	var z = this.zones[zon];
	z.zoom.actif = !z.zoom.actif;
	log(currentFunctionName, '(zon=' + zon + ') [zone.zoom.actif=' + z.zoom.actif + ']');
	this.afficheImage(this.getCurrentImageId(zon), zon);
};

//___________________________________________________
// Permet de permuter 2 style CSS sur un élément
//___________________________________________________
projet.switchCSS = function (element, oldStyle, newStyle) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.switchCSS';
	log(currentFunctionName, '(element=' + element + ', oldStyle=' + oldStyle + ', newStyle=' + newStyle + ')');
	document.querySelector('#' + element).classList.remove(oldStyle);
	document.querySelector('#' + element).classList.add(newStyle);
};

//___________________________________________________
//Création des fenêtre de zoom et liaison avec les actions jQuery
//___________________________________________________
projet.initEnvBox = function (varId) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.initEnvBox';
	var v = this.variables[varId];
	log(currentFunctionName, '(varId=' + varId + ')');
	if (v.environnement == true) {
		// Ajout des entrées de menu
		var onoff = 'off';
		if (v.visible) {
			onoff = 'on';
		}
		var txt = "<li class='subItem'>" + "<a id='mnuEnv_" + varId + "' class='checked " + onoff + "' href='#' onclick='projet.toggleVar(" + '"' + varId + '"' + ")'>" + v.titre + '</a></li>';
		document.querySelector('#mnuMainEnv').innerHTML = document.querySelector('#mnuMainEnv').innerHTML + txt;

		// Ajout des div zoom
		var display = '';
		if (v.visible) display = ' style="display: block;"';

		txt = `<div id='var_${varId}' initialized='true' class='varBox window hide'${display}>
					<div class='header'>
						<span class='window_title'>${v.titre}</span>
						<div class='zoomtoolbarbutton'>
							<img id='closebuttonvar_${varId}' src='images/exit.png' alt='fermer'></img>
						</div>
					</div>
					<div class='varContent'>
						<label for='varValue_${varId}'>Sélectionnez la valeur de votre variable</label>
						<select class='varSelect' id='varValue_${varId}' name='varValue_${varId}' size='1'>`;
		for (var varval in v.contenus) {
			txt += `<option value='${varval}' data-varid='${varId}'`;
			if (v.valeur == varval) {
				txt += ` selected='selected'`;
			}
			txt += `>${v.contenus[varval]}</option>`;
		}
		txt += `</select></div></div>`;
		document.querySelector('#zoomsDiv').innerHTML += txt;

		interact('#var_' + varId)
			.resizable({
				edges: { left: true, right: true, bottom: true, top: false },
				listeners: {
					move(event) {
						resizing = true;
						var target = event.target;

						var x = parseFloat(target.getAttribute('data-x')) || 0;
						var y = parseFloat(target.getAttribute('data-y')) || 0;

						// update the element's style
						target.style.width = event.rect.width + 'px';
						target.style.height = event.rect.height + 'px';

						// translate when resizing from top or left edges
						x += event.deltaRect.left;
						y += event.deltaRect.top;

						target.style.webkitTransform = target.style.transform = 'translate(' + x + 'px,' + y + 'px)';

						target.setAttribute('data-x', x);
						target.setAttribute('data-y', y);
					},
				},
				modifiers: [
					// keep the edges inside the parent
					// interact.modifiers.restrictEdges({
					// 	outer: 'body',
					// }),

					// minimum size
					interact.modifiers.restrictSize({
						min: { width: 125, height: 150 },
					}),
				],

				inertia: false,
			})
			.draggable({
				allowFrom: '.header',
				listeners: { move: window.dragMoveListener },
				inertia: true,
				modifiers: [
					interact.modifiers.restrictRect({
						restriction: '#mainContaint',
						endOnly: true,
					}),
				],
			});
	}
};

//___________________________________________________
// Création des fenêtre de zoom et liaison avec les actions jQuery
//___________________________________________________
projet.initZoomBox = function (zoneId) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.initZoomBox';
	var z = this.zones[zoneId];
	log(currentFunctionName, '(zoneId=' + zoneId + ') [zone.zoom.autorise=' + z.zoom.autorise + ']');
	if (z.zoom.autorise == true) {
		// Ajout des entrées de menu
		var onoff = 'off';
		if (z.zoom.visible) {
			onoff = 'on';
		}
		var txt = "<li class='subItem'>" + "<a id='mnuZoom_" + zoneId + "' class='checked " + onoff + "' href='#' onclick='projet.toggleZoom(" + '"' + zoneId + '"' + ")'>" + z.nom + '</a></li>';
		document.querySelector('#mnuMain2').innerHTML += txt;

		var display = '';
		if (z.zoom.visible) display = ' style="display: block;"';
		txt = `<div id='${z.zoom.id}' initialized='false' class='window hide'${display}>
				<div class='header'>
					<span class='window_title'>${z.nom}</span>
					<div class='zoomtoolbarbutton'>
						<img id='zoombutton${zoneId}' src='images/zoom.png' alt='zoomer'></img>
						<img id='closebutton${zoneId}' src='images/exit.png' alt='fermer'></img>
					</div>
				</div>
				<canvas id='canvaszoom${zoneId}' width='2000px' height='2000px'></canvas>
			</div>`;
		document.querySelector('#zoomsDiv').innerHTML += txt;

		interact('#' + z.zoom.id)
			.resizable({
				edges: { left: true, right: true, bottom: true, top: false },
				listeners: {
					move(event) {
						resizing = true;
						var target = event.target;

						var x = parseFloat(target.getAttribute('data-x')) || 0;
						var y = parseFloat(target.getAttribute('data-y')) || 0;

						// update the element's style
						target.style.width = event.rect.width + 'px';
						target.style.height = event.rect.height + 'px';

						// translate when resizing from top or left edges
						x += event.deltaRect.left;
						y += event.deltaRect.top;

						target.style.webkitTransform = target.style.transform = 'translate(' + x + 'px,' + y + 'px)';

						target.setAttribute('data-x', x);
						target.setAttribute('data-y', y);
						projet.resizeZoomBox(zoneId);
					},
				},
				modifiers: [
					// keep the edges inside the parent
					// interact.modifiers.restrictEdges({
					// 	outer: 'body',
					// }),

					// minimum size
					interact.modifiers.restrictSize({
						min: { width: 125, height: 150 },
					}),
				],

				inertia: false,
			})
			.draggable({
				allowFrom: '.header',
				listeners: { move: window.dragMoveListener },
				inertia: true,
				modifiers: [
					interact.modifiers.restrictRect({
						restriction: '#mainContaint',
						endOnly: true,
					}),
				],
			});
	}
};

//___________________________________________________
//Initialise une des actions (up,down, left,right, zoom +/- sur la zone de zoom
//___________________________________________________
projet.initZoomBoxAction = function (zon, actionName, xx, yy) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.initZoomBoxAction';
	log(currentFunctionName, '(zon=' + zon + ', actionName=' + actionName + ',xx=' + xx + ', yy=' + yy + ')');
	var z = this.zones[zon];
	z.zoom.actions[actionName] = {
		x: xx,
		y: yy,
		largeur: 32,
		hauteur: 32,
		nom: actionName,
		zoneId: zon,
		imageId: actionName + 'On',
		actionStart: projet.startAction,
		actionMove: projet.rienFaire,
		actionStop: projet.stopAction,
	};
};

//___________________________________________________
//Initialsie toutes les actions scroll/zoom sur la zone de zoom
//___________________________________________________
projet.initZoomBoxActions = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.initZoomBoxActions';
	log(currentFunctionName, '(zon=' + zon + ')');
	var z = this.zones[zon];
	projet.initZoomBoxAction(zon, 'up', z.zoom.largeurBox / 2 - 16, 0);
	projet.initZoomBoxAction(zon, 'down', z.zoom.largeurBox / 2 - 16, z.zoom.hauteurBox - 60);
	projet.initZoomBoxAction(zon, 'left', 0, z.zoom.hauteurBox / 2 - 16);
	projet.initZoomBoxAction(zon, 'right', z.zoom.largeurBox - 32, z.zoom.hauteurBox / 2 - 16);
	projet.initZoomBoxAction(zon, 'zoomplus', z.zoom.largeurBox / 2 - 48, z.zoom.hauteurBox / 2 - 16);
	projet.initZoomBoxAction(zon, 'zoommoins', z.zoom.largeurBox / 2 + 18, z.zoom.hauteurBox / 2 - 16);
};

//___________________________________________________
//Rédimensionne la zone de zoom et replace les sliders aux bons endroits
//___________________________________________________
projet.resizeZoomBox = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.resizeZoomBox';
	var z = this.zones[zon];
	z.zoom.largeurBox = parseFloat(getComputedStyle(document.querySelector('#' + z.zoom.id), null).width.replace('px', ''));
	z.zoom.hauteurBox = parseFloat(getComputedStyle(document.querySelector('#' + z.zoom.id), null).height.replace('px', ''));
	if (z.zoom.largeurBox == 0) z.zoom.largeurBox = defaultWindowSize;
	if (z.zoom.hauteurBox == 0) z.zoom.hauteurBox = defaultWindowSize;
	z.zoom.actions['up'].x = z.zoom.largeurBox / 2 - 16;
	z.zoom.actions['down'].x = z.zoom.largeurBox / 2 - 16;
	z.zoom.actions['down'].y = z.zoom.hauteurBox - 60;
	z.zoom.actions['left'].y = z.zoom.hauteurBox / 2 - 16;
	z.zoom.actions['right'].x = z.zoom.largeurBox - 32;
	z.zoom.actions['right'].y = z.zoom.hauteurBox / 2 - 16;
	z.zoom.actions['zoomplus'].x = z.zoom.largeurBox / 2 - 48;
	z.zoom.actions['zoomplus'].y = z.zoom.hauteurBox / 2 - 16;
	z.zoom.actions['zoommoins'].x = z.zoom.largeurBox / 2 + 18;
	z.zoom.actions['zoommoins'].y = z.zoom.hauteurBox / 2 - 16;
	log(currentFunctionName, '(zon=' + zon + ') [xUp=' + z.zoom.actions['up'].x + ', xDown=' + z.zoom.actions['down'].x + ', largeurBox=' + z.zoom.largeurBox + ', hauteurBox=' + z.zoom.hauteurBox + ',]');
	this.afficheImage(this.getCurrentImageId(zon), zon);
};

//___________________________________________________
//Procédure vide (utilisée en réponse à des actions non utilisées)
//___________________________________________________
projet.rienFaire = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.rienFaire';
	log(currentFunctionName, '()');
};

//___________________________________________________
//Défini pour la zone passée en paramètre et chaque bouton (scroll/zoom)
//s'il est actif ou non en fonction de la portion d'image affichée et du niveau de zoom
//___________________________________________________
projet.adjustButtonStyle = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.adjustButtonStyle';
	log(currentFunctionName, '(zon=' + zon + ')');
	var z = this.zones[zon];
	var xDroitImage = (z.zoom.xImage + z.largeur) * z.zoom.ratio;
	var yBasImage = (z.zoom.yImage + z.hauteur) * z.zoom.ratio;
	this.setBoutonOnOff(zon, 'up', yBasImage > z.zoom.hauteurBox);
	this.setBoutonOnOff(zon, 'down', z.zoom.yImage < 0);
	this.setBoutonOnOff(zon, 'left', xDroitImage > z.zoom.largeurBox);
	this.setBoutonOnOff(zon, 'right', z.zoom.xImage < 0);
	this.setBoutonOnOff(zon, 'zoomplus', z.zoom.ratio < 5);
	this.setBoutonOnOff(zon, 'zoommoins', z.zoom.ratio > 1);
};

//___________________________________________________
//Change l'apparence on/off d'un bouton (zoom/scroll) en fonction de la valeur du test
//DEPRECATED : remplacée par setBoutonOnOff
//___________________________________________________
projet.setButtonOnOff = function (buttonId, test) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.setButtonOnOff';
	log(currentFunctionName, '(buttonId=' + zon + ', test=' + test + ')');
	if (test) this.switchCSS(buttonId, 'off', 'on');
	else this.switchCSS(buttonId, 'on', 'off');
};

//___________________________________________________
//Change l'apparence on/off d'un bouton (zoom/scroll) en fonction de la valeur du test
//___________________________________________________
projet.setBoutonOnOff = function (zon, buttonId, test) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.setBoutonOnOff';
	log(currentFunctionName, '(zon=' + zon + ', buttonId=' + zon + ', test=' + test + ')');
	var z = this.zones[zon];
	if (test) {
		z.zoom.actions[buttonId].image = projet.icones[buttonId].imgon;
		z.zoom.actions[buttonId].actif = true;
	} else {
		z.zoom.actions[buttonId].image = projet.icones[buttonId].imgoff;
		z.zoom.actions[buttonId].actif = false;
	}
};

//___________________________________________________
//Démarre une action scroll/zoom sur une zone de zoom
//___________________________________________________
projet.startAction = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.startAction';
	log(currentFunctionName, '() [this.nom=' + this.nom + ', this.zoneId=' + this.zoneId + ']');
	// Attention dans la ligne qui suit this.nom et this.zoneId sont des champs d'une variable projet.zone.zoom.Action[xxx]
	// Voir définition de cette partir dans la méthode projet.initZoomBoxAction(...)
	if (this.nom == 'up' || this.nom == 'down' || this.nom == 'left' || this.nom == 'right') projet.startScroll(this.nom, this.zoneId);
	else if (this.nom == 'zoomplus' || this.nom == 'zoommoins') projet.startZoom(this.nom, this.zoneId);
};

//___________________________________________________
//Lance l'arrêt de l'action scroll/zoom sur une zone de zoom
//___________________________________________________
projet.stopAction = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.stopAction';
	log(currentFunctionName, '() [this.nom=' + this.nom + ', this.zoneId=' + this.zoneId + ']');
	if (this.nom == 'up' || this.nom == 'down' || this.nom == 'left' || this.nom == 'right') projet.stopScroll();
	else if (this.nom == 'zoomplus' || this.nom == 'zoommoins') projet.stopZoom();
};

//___________________________________________________
//Action sans effet sur les zones de zoom (prévu en cas d'évolutiun)
//___________________________________________________
projet.moveAction = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.moveAction';
	log(currentFunctionName, '()');
};

//___________________________________________________
//Action de zoom sur la zone (zoom entre 1 et 5)
//___________________________________________________
projet.zoomIn = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.zoomIn';
	var z = projet.zones[currentZone];
	var oldRation = z.zoom.ratio;
	if (z.zoom.ratio < 5) {
		z.zoom.ratio = z.zoom.ratio + 0.1;
		z.zoom.context.scale(z.zoom.ratio / oldRation, z.zoom.ratio / oldRation);
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, '() [currentZone=' + currentZone + ', oldRation=' + oldRation + ', zone.zoom.ratio=' + z.zoom.ratio + ']');
};

//___________________________________________________
//Action de dézoom sur la zone (zoom entre 1 et 5)
//___________________________________________________
projet.zoomOut = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.zoomOut';
	var z = projet.zones[currentZone];
	var oldRation = z.zoom.ratio;
	if (z.zoom.ratio > 1) {
		z.zoom.ratio = z.zoom.ratio - 0.1;
		z.zoom.context.scale(z.zoom.ratio / oldRation, z.zoom.ratio / oldRation);
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, '() [currentZone=' + currentZone + ', oldRation=' + oldRation + ', zone.zoom.ratio=' + z.zoom.ratio + ']');
};

//___________________________________________________
//Démarre une action de zoom/dézoom
//___________________________________________________
projet.startZoom = function (nom, zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.startZoom';
	clearInterval(Id_Timer);
	currentZone = zon;
	var time = 100;
	if (nom == 'zoomplus')
		Id_Timer = setInterval(function () {
			projet.zoomIn();
		}, time);
	if (nom == 'zoommoins')
		Id_Timer = setInterval(function () {
			projet.zoomOut();
		}, time);
	log(currentFunctionName, '() [currentZone=' + currentZone + ']');
};

//___________________________________________________
//Stoppe une action de zoom/dézoom (arrêt du timer)
//___________________________________________________
projet.stopZoom = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.stopZoom';
	clearInterval(Id_Timer);
	log(currentFunctionName, '() [currentZone=' + currentZone + ']');
};

//___________________________________________________
//Lance le scroll de la zone dans la direction demandée
//___________________________________________________
projet.startScroll = function (sens, zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.startScroll';
	clearInterval(Id_Timer);
	currentZone = zon;
	log(currentFunctionName, '(sens=' + sens + ', zon=' + zon + ')');

	var time = 10;
	if (sens == 'left')
		Id_Timer = setInterval(function () {
			projet.scrollGauche();
		}, time);
	if (sens == 'right')
		Id_Timer = setInterval(function () {
			projet.scrollDroite();
		}, time);
	if (sens == 'up')
		Id_Timer = setInterval(function () {
			projet.scrollHaut();
		}, time);
	if (sens == 'down')
		Id_Timer = setInterval(function () {
			projet.scrollBas();
		}, time);
};

//___________________________________________________
//Arrête le timer lié au scroll
//___________________________________________________
projet.stopScroll = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.stopScroll';
	log(currentFunctionName, '()');
	clearInterval(Id_Timer);
};

//___________________________________________________
//Défile la zone vers la gauche
//___________________________________________________
projet.scrollGauche = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.scrollGauche';
	var z = this.zones[currentZone];
	var xDroitImage = (z.zoom.xImage + z.largeur) * z.zoom.ratio;
	if (xDroitImage > z.zoom.largeurBox) {
		z.zoom.xImage--;
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, ' () : [zone=' + currentZone + ' , xDroitImage=' + xDroitImage + ', xImage=' + z.zoom.xImage + ']');
};

//___________________________________________________
//Défile la zone vers la droite
//___________________________________________________
projet.scrollDroite = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.scrollDroite';
	var z = this.zones[currentZone];
	if (z.zoom.xImage < 0) {
		z.zoom.xImage++;
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, ' () : [zone=' + currentZone + ' , xImage=' + z.zoom.xImage + ']');
};

//___________________________________________________
//Défile la zone vers le haut
//___________________________________________________
projet.scrollHaut = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.scrollHaut';
	var z = this.zones[currentZone];
	var yBasImage = (z.zoom.yImage + z.hauteur) * z.zoom.ratio;
	if (yBasImage > z.zoom.hauteurBox) {
		z.zoom.yImage--;
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, ' () : [zone=' + currentZone + ' , yBasImage=' + yBasImage + ', yImage=' + z.zoom.yImage + ']');
};

//___________________________________________________
//Défile la zone vers le bas
//___________________________________________________
projet.scrollBas = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.scrollBas';
	var z = this.zones[currentZone];
	if (z.zoom.yImage < 0) {
		z.zoom.yImage++;
		this.recalculeCentreZoom(currentZone);
		this.afficheImage(this.getCurrentImageId(currentZone), currentZone);
	}
	log(currentFunctionName, ' () : [zone=' + currentZone + ' , yImage=' + z.zoom.yImage + ']');
};

//......................................................................................................
//______________________________________________________________________________________________________
// Partie Evenements : Cette partie gère les évènements souris/doigt
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// Gestion du mouseDown sur sur un bouton dans une zone de zoom
//___________________________________________________
projet.mousedownInZoomBox = function (canvas, evt) {
	if (resizing) return;
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mousedownInZoomBox';
	var mouse = evt.type != 'touchstart' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	var zon = canvas.id.replace('canvaszoom', '');
	log(currentFunctionName, '(canvas=' + zon + '.canvas, evt=xxx) [mouse=(' + mouse.x + ',' + mouse.y + ')]');
	var z = projet.zones[zon];

	// Gestion des "mousedown" sur la zone quand les bontons sont actifs
	if (z.zoom.actif) {
		var act = z.zoom.actions;
		if (isMouseInRectangle(mouse, act.up.x, act.up.y, act.up.largeur, act.up.hauteur)) act.up.actionStart();
		else if (isMouseInRectangle(mouse, act.down.x, act.down.y, act.down.largeur, act.down.hauteur)) act.down.actionStart();
		else if (isMouseInRectangle(mouse, act.left.x, act.left.y, act.left.largeur, act.left.hauteur)) act.left.actionStart();
		else if (isMouseInRectangle(mouse, act.right.x, act.right.y, act.right.largeur, act.right.hauteur)) act.right.actionStart();
		else if (isMouseInRectangle(mouse, act.zoomplus.x, act.zoomplus.y, act.zoomplus.largeur, act.zoomplus.hauteur)) act.zoomplus.actionStart();
		else if (isMouseInRectangle(mouse, act.zoommoins.x, act.zoommoins.y, act.zoommoins.largeur, act.zoommoins.hauteur)) act.zoommoins.actionStart();
		return;
	}
	zon = projet.getZoneUnderMouse(mouse, 'ZoomBox');
	if (this.isActive(zon)) {
		mousedrag = true;
		currentDragZone = canvas.id.replace('canvaszoom', '');
		oldMouse.x = mouse.x;
		oldMouse.y = mouse.y;
		log(currentFunctionName, '(canvas=' + zon + '.canvas, evt=xxx) [mouse=(' + mouse.x + ',' + mouse.y + ', oldMouse=(' + oldMouse.x + ',' + oldMouse.y + ', mouseDrag=' + mousedrag + ', currentDragZone=' + currentDragZone + '])');
	}
};

//___________________________________________________
// Gestion du mouseMove sur sur un bouton dans une zone de zoom
//___________________________________________________
projet.mousemoveInZoomBox = function (canvas, evt) {
	if (resizing) return;
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mousemoveInZoomBox';
	var mouse = evt.type != 'touchmove' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	var zon = canvas.id.replace('canvaszoom', '');
	log(currentFunctionName, '(canvas=' + zon + '.canvas, evt=xxx) : [mouse=(' + mouse.x + ',' + mouse.y + ', mouseDrag=' + mousedrag + ', currentDragZone=' + currentDragZone + '])');
	var z = projet.zones[zon];
	if (z == null || z == undefined) return;
	if (z.zoom.actif) {
		// Gestion des "mousemove" sur la zone quand les bontons sont actifs
		var act = z.zoom.actions;
		if (isMouseInRectangle(mouse, act.up.x, act.up.y, act.up.largeur, act.up.hauteur)) act.up.actionMove();
		else if (isMouseInRectangle(mouse, act.down.x, act.down.y, act.down.largeur, act.down.hauteur)) act.down.actionMove();
		else if (isMouseInRectangle(mouse, act.left.x, act.left.y, act.left.largeur, act.left.hauteur)) act.left.actionMove();
		else if (isMouseInRectangle(mouse, act.right.x, act.right.y, act.right.largeur, act.right.hauteur)) act.right.actionMove();
		else if (isMouseInRectangle(mouse, act.zoomplus.x, act.zoomplus.y, act.zoomplus.largeur, act.zoomplus.hauteur)) act.zoomplus.actionMove();
		else if (isMouseInRectangle(mouse, act.zoommoins.x, act.zoommoins.y, act.zoommoins.largeur, act.zoommoins.hauteur)) act.zoommoins.actionMove();
		else {
			act.up.actionStop();
			act.down.actionStop();
			act.left.actionStop();
			act.right.actionStop();
			act.zoomplus.actionStop();
			act.zoommoins.actionStop();
		}
		return;
	}
	zon = projet.getZoneUnderMouse(mouse, 'ZoomBox');
	if (this.isActive(zon)) {
		var zon = canvas.id.replace('canvaszoom', '');
		var z = projet.zones[zon];
		if (projet.isActive(zon)) canvas.style.cursor = 'pointer';
		else canvas.style.cursor = 'default';
		log(currentFunctionName, '(...) zone=' + zon + ', zone.type=' + z.type + ')');
		if (mousedrag && zon == currentDragZone) {
			switch (z.type) {
				case 'rotation':
					theta = rad2deg(calculAngle(z.zoom.xCentreImageRatio, z.zoom.yCentreImageRatio, oldMouse.x, oldMouse.y, mouse.x, mouse.y));
					if (Math.abs(theta) > Math.abs(z.pas)) {
						oldMouse.x = mouse.x;
						oldMouse.y = mouse.y;
						log(currentFunctionName, '(...) AVANT [zone=' + zon + ', theta=' + theta + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
						if (z.orientation == 'horaire') {
							if (theta < 0) projet.getNextValue(z.variable);
							else projet.getPreviousValue(z.variable);
						}
						if (z.orientation == 'anti horaire') {
							if (theta < 0) projet.getPreviousValue(z.variable);
							else projet.getNextValue(z.variable);
						}
						log(currentFunctionName, '(...) APRES [zone=' + zon + ', theta=' + theta + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					}
					break;
				case 'horizontal':
					var deltax = mouse.x - oldMouse.x;
					if (Math.abs(deltax) > Math.abs(z.pas * z.zoom.ratio)) {
						oldMouse.x = mouse.x;
						oldMouse.y = mouse.y;
						log(currentFunctionName, '(...) AVANT [zone=' + zon + ', deltax=' + deltax + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
						if (z.orientation == 'gauche') {
							if (deltax < 0) projet.getNextValue(z.variable);
							else projet.getPreviousValue(z.variable);
						}
						if (z.orientation == 'droite') {
							if (deltax < 0) projet.getPreviousValue(z.variable);
							else projet.getNextValue(z.variable);
						}
						log(currentFunctionName, '(...) APRES [zone=' + zon + ', deltax=' + deltax + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					}
					break;
				case 'vertical':
					var deltay = mouse.y - oldMouse.y;
					if (Math.abs(deltay) > Math.abs(z.pas * z.zoom.ratio)) {
						oldMouse.x = mouse.x;
						oldMouse.y = mouse.y;
						log(currentFunctionName, '(...) AVANT [zone=' + zon + ', deltay=' + deltay + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
						if (z.orientation == 'haut') {
							if (deltay < 0) projet.getNextValue(z.variable);
							else projet.getPreviousValue(z.variable);
						}
						if (z.orientation == 'bas') {
							if (deltay < 0) projet.getPreviousValue(z.variable);
							else projet.getNextValue(z.variable);
						}
						log(currentFunctionName, '(...) APRES [zone=' + zon + ', deltay=' + deltay + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					}
					break;
				case 'autre.....':
					break;
			}
		}
	}
};

//___________________________________________________
// Gestion du mouseUp sur sur un bouton dans une zone de zoom
//___________________________________________________
projet.mouseupInZoomBox = function (canvas, evt) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mouseupInZoomBox';
	var mouse = evt.type != 'touchend' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	var zon = canvas.id.replace('canvaszoom', '');
	log(currentFunctionName, '(canvas=' + zon + '.canvas, evt=xxx) [mouse=(' + mouse.x + ',' + mouse.y + ')]');
	var z = projet.zones[zon];
	if (z.zoom.actif) {
		// Gestion des "mouseup" sur la zone quand les bontons sont actifs
		var act = z.zoom.actions;
		if (isMouseInRectangle(mouse, act.up.x, act.up.y, act.up.largeur, act.up.hauteur)) act.up.actionStop();
		else if (isMouseInRectangle(mouse, act.down.x, act.down.y, act.down.largeur, act.down.hauteur)) act.down.actionStop();
		else if (isMouseInRectangle(mouse, act.left.x, act.left.y, act.left.largeur, act.left.hauteur)) act.left.actionStop();
		else if (isMouseInRectangle(mouse, act.right.x, act.right.y, act.right.largeur, act.right.hauteur)) act.right.actionStop();
		else if (isMouseInRectangle(mouse, act.zoomplus.x, act.zoomplus.y, act.zoomplus.largeur, act.zoomplus.hauteur)) act.zoomplus.actionStop();
		else if (isMouseInRectangle(mouse, act.zoommoins.x, act.zoommoins.y, act.zoommoins.largeur, act.zoommoins.hauteur)) act.zoommoins.actionStop();
	} else {
		mousedrag = false;
	}
};

//___________________________________________________
//Gestion du mouseDown sur sur un bouton dans la zone principale
//___________________________________________________
projet.mousedownInMainBox = function (canvas, evt) {
	if (resizing) return;
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mousedownInMainBox';
	var mouse = evt.type == 'mousedown' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	mousedrag = true;
	currentDragZone = projet.getZoneUnderMouse(mouse, 'MainBox');
	oldMouse.x = mouse.x;
	oldMouse.y = mouse.y;
	log(currentFunctionName, '(canvas=mainCanvas, evt=xxx) : [mouse=(' + mouse.x + ',' + mouse.y + ', oldMouse=(' + oldMouse.x + ',' + oldMouse.y + ', mouseDrag=' + mousedrag + ', currentDragZone=' + currentDragZone + '])');
};
//___________________________________________________
//Gestion du mouseMove sur sur un bouton dans la zone principale
//___________________________________________________
projet.mousemoveInMainBox = function (canvas, evt) {
	if (resizing) return;
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mousemoveInMainBox';
	var mouse = evt.type == 'mousemove' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	var zon = projet.getZoneUnderMouse(mouse, 'MainBox');
	log(currentFunctionName, '(canvas=mainCanvas, evt=xxx) : [mouse=(' + mouse.x + ',' + mouse.y + ', mouseDrag=' + mousedrag + ', currentDragZone=' + currentDragZone + '])');
	var z = projet.zones[zon];
	if (z == null || z == undefined) return;
	if (projet.isActive(zon)) {
		canvas.style.cursor = 'pointer';
	} else canvas.style.cursor = 'default';
	if (mousedrag && zon == currentDragZone) {
		log(currentFunctionName, '(...) zone=' + zon + ', zone.type=' + z.type + ')');
		switch (z.type) {
			case 'rotation':
				var theta = rad2deg(calculAngle(z.xCentre, z.yCentre, oldMouse.x, oldMouse.y, mouse.x, mouse.y));
				if (Math.abs(theta) > Math.abs(z.pas)) {
					oldMouse.x = mouse.x;
					oldMouse.y = mouse.y;
					log(currentFunctionName, '(...) AVANT [zone=' + zon + ', theta=' + theta + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					if (z.orientation == 'horaire') {
						if (theta < 0) projet.getNextValue(z.variable);
						else projet.getPreviousValue(z.variable);
					}
					if (z.orientation == 'anti horaire') {
						if (theta < 0) projet.getPreviousValue(z.variable);
						else projet.getNextValue(z.variable);
					}
					log(currentFunctionName, '(...) APRES [zone=' + zon + ', theta=' + theta + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
				}
				break;
			case 'horizontal':
				var deltax = mouse.x - oldMouse.x;
				if (Math.abs(deltax) > Math.abs(z.pas)) {
					oldMouse.x = mouse.x;
					oldMouse.y = mouse.y;
					log(currentFunctionName, '(...) AVANT [zone=' + zon + ', deltax=' + deltax + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					if (z.orientation == 'gauche') {
						if (deltax < 0) projet.getNextValue(z.variable);
						else projet.getPreviousValue(z.variable);
					}
					if (z.orientation == 'droite') {
						if (deltax < 0) projet.getPreviousValue(z.variable);
						else projet.getNextValue(z.variable);
					}
					log(currentFunctionName, '(...) APRES [zone=' + zon + ', deltax=' + deltax + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
				}
				break;
			case 'vertical':
				var deltay = mouse.y - oldMouse.y;
				if (Math.abs(deltay) > Math.abs(z.pas)) {
					oldMouse.x = mouse.x;
					oldMouse.y = mouse.y;
					log(currentFunctionName, '(...) AVANT [zone=' + zon + ', deltay=' + deltay + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
					if (z.orientation == 'haut') {
						if (deltay < 0) projet.getNextValue(z.variable);
						else projet.getPreviousValue(z.variable);
					}
					if (z.orientation == 'bas') {
						if (deltay < 0) projet.getPreviousValue(z.variable);
						else projet.getNextValue(z.variable);
					}
					log(currentFunctionName, '(...) APRES [zone=' + zon + ', deltay=' + deltay + ', imagecourante=' + projet.getCurrentImageId(zon) + ']');
				}
				break;
			case 'autre.....':
				break;
		}
	}
};

function leaveBox(canvas, evt, currentFunctionName) {
	var mouse = getMouseLocation(canvas, evt);
	mousedrag = false;
	log(currentFunctionName, '(canvas=mainCanvas, evt=xxx) : [mouse=(' + mouse.x + ',' + mouse.y + ', oldMouse=(' + oldMouse.x + ',' + oldMouse.y + ', mouseDrag=' + mousedrag + '])');
}
//___________________________________________________
//Gestion du mouseOut sur un bouton dans la zone principale
//___________________________________________________
projet.mouseoutInMainBox = function (canvas, evt) {
	var currentFunctionName = 'projet.mouseoutInMainBox';
	leaveBox(canvas, evt, currentFunctionName);
};
projet.mouseoverInMainBox = function (canvas, evt) {
	var currentFunctionName = 'projet.mouseoverInMainBox';
	leaveBox(canvas, evt, currentFunctionName);
};
//___________________________________________________
//Gestion du mouseOver sur un bouton dans la zone zoombox
//___________________________________________________
projet.mouseoverInZoomBox = function (canvas, evt) {
	var currentFunctionName = 'projet.mouseoverInZoomBox';
	leaveBox(canvas, evt, currentFunctionName);
};
projet.mouseoutInZoomBox = function (canvas, evt) {
	var currentFunctionName = 'projet.mouseoutInZoomBox';
	leaveBox(canvas, evt, currentFunctionName);
};
//___________________________________________________
//Gestion du mouseUp sur sur un bouton dans la zone principale
//___________________________________________________
projet.mouseupInMainBox = function (canvas, evt) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.mouseupInMainBox';
	var mouse = evt.type == 'mouseup' ? getMouseLocation(canvas, evt) : getTouchLocation(canvas, evt);
	mousedrag = false;
	log(currentFunctionName, '(canvas=mainCanvas, evt=xxx) : [mouse=(' + mouse.x + ',' + mouse.y + ', oldMouse=(' + oldMouse.x + ',' + oldMouse.y + ', mouseDrag=' + mousedrag + '])');

	var zon = projet.getZoneUnderMouse(mouse, 'MainBox');
	var z = projet.zones[zon];
	if (z == null || z == undefined) return;
	switch (z.type) {
		case 'bouton':
			let valAct = this.variables[z.variable].valeur;
			projet.getNextValue(z.variable);
			if (valAct == this.variables[z.variable].valeur && z.buttonRepeat) this.changeEtatVariable(z.variable, 'c' + 1);
			break;

		case 'stockage':
			if (currentVarTriple != null) {
				console.log(`fil ${this.variables[currentVarTriple].titre} déposé !`);
				this.changeEtatVariable(currentVarTriple, this.variables[currentVarTriple].defaut);
				currentVarTriple = null;
				connections = [];
			} else {
				for (let vname in this.variables) {
					let v = this.variables[vname];
					if (!v.vartriple) continue;
					if (v.contenus[v.defaut].toLowerCase().startsWith('[' + zon + ';;') && v.defaut == v.valeur) {
						currentVarTriple = vname;
						break;
					}
				}
				if (currentVarTriple == null) {
					console.log("aucun fil n'est disponible.");
					return;
				}
				console.log(`fil ${this.variables[currentVarTriple].titre} en main !`);
				this.context.fillStyle = 'rgba(0,0,0,0.5)';
				const canvas = document.querySelector('#mainCanvas');
				this.context.fillRect(0, 0, canvas.getBoundingClientRect().width, canvas.getBoundingClientRect().height);
				for (let zname in this.zones) {
					var zone = this.zones[zname];
					if (zone.type == 'branchement') {
						let borderColor = 'rgb(' + this.couleurZones.branchements.red + ',' + this.couleurZones.branchements.green + ',' + this.couleurZones.branchements.blue + ')';
						drawRect(this.context, zone.x + 1, zone.y + 1, zone.largeur - 2, zone.hauteur - 2, borderColor, 2);
					}
				}
				let borderColor = 'rgb(' + this.couleurZones.stockage.red + ',' + this.couleurZones.stockage.green + ',' + this.couleurZones.stockage.blue + ')';
				drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
			}
			break;

		case 'branchement':
			if (connections.push(zon) == 2) {
				// on échante les places pour suivre l'ordre zone1, zone2, zone3, ...
				if (connections[0] > connections[1]) {
					let tmp = connections[0];
					connections[0] = connections[1];
					connections[1] = tmp;
				}
				let link = `${connections[0]};;${connections[1]}]`;
				connections = [];

				if (currentVarTriple == null) {
					//si débrancher
					let last = null;
					for (let vname in this.variables) {
						const v = this.variables[vname]; //variable à remettre à 0
						if (last != null) {
							// last la variable juste avant
							// v la variable actuelle
							const result = varTripleContainsValue(this.variables[last], v.contenus[v.valeur], true);
							this.variables[last].valeur = result;
							console.log(`${v.titre}:${v.valeur} -> ${this.variables[last].titre}:${this.variables[last].valeur} !`);
							last = vname;
						}
						if (v.contenus[v.valeur].toLowerCase().endsWith(link) && last == null) {
							last = vname;
						}
					}
					if(last!=null) this.changeEtatVariable(last, this.variables[last].defaut);
				} else {
					let backup = JSON.parse(JSON.stringify(this.variables));
					//si brancher
					const variable = this.variables[currentVarTriple];
					let cnamefinal = varTripleContainsValue(variable, link, true);
					const result = allVarTripleContainsValue(link, true);

					if (result != null && variable != this.variables[result.variable]) {
						const secondVar = this.variables[result.variable];
						if (cnamefinal == null || secondVar.contenus[secondVar.valeur] > variable.contenus[cnamefinal]) {
							let result2 = varTripleContainsValue(variable, secondVar.contenus[secondVar.valeur], true);
							if (result2 != null) {
								secondVar.valeur = result.valeur; // on change la valeur sans changer l'image pour ne pas modifier deux fois l'image
								cnamefinal = result2;
								console.log(`Fils ${secondVar.titre} et ${variable.titre} inversés !`);
							}
						}
					}

					if (cnamefinal != null) {
						this.variables[currentVarTriple].valeur = cnamefinal;
						let tmp = '';
						for (let vname in this.variables) {
							tmp += vname;
							tmp += this.variables[vname].valeur;
						}
						if (tmp in this.associations) {
							this.changeEtatVariable(currentVarTriple, cnamefinal);
						} else {
							this.variables = backup;
							alert("Le branchement n'est pas possible.");
							this.afficheImages();
						}

						connections = [];
						currentVarTriple = null;
					}
				}
			}
			break;
	}
};

//___________________________________________________
// Active les évènements souris associés à chaque canvas
//___________________________________________________
projet.addListeners = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.addListeners';
	log(currentFunctionName, '()');
	const canvas = document.querySelector('#mainCanvas');

	canvas.addEventListener('mousedown', event => projet.mousedownInMainBox(canvas, event));
	canvas.addEventListener('touchstart', event => projet.mousedownInMainBox(canvas, event));

	canvas.addEventListener('mouseup', event => projet.mouseupInMainBox(canvas, event));
	canvas.addEventListener('touchend', event => projet.mouseupInMainBox(canvas, event));

	canvas.addEventListener('mousemove', event => projet.mousemoveInMainBox(canvas, event));
	canvas.addEventListener('touchmove', event => projet.mousemoveInMainBox(canvas, event));

	canvas.addEventListener('mouseout', event => leaveBox(canvas, event, 'projet.mouseoutInMainBox'));
	canvas.addEventListener('mouseover', event => leaveBox(canvas, event, 'projet.mouseoverInMainBox'));

	for (var zon in this.zones) {
		var z = projet.zones[zon];
		if (z.zoom.autorise) {
			const canvaszoom = document.querySelector('#canvaszoom' + zon);
			canvaszoom.addEventListener('mousedown', evt => projet.mousedownInZoomBox(canvaszoom, evt));
			canvaszoom.addEventListener('touchstart', evt => projet.mousedownInZoomBox(canvaszoom, evt));

			canvaszoom.addEventListener('mousemove', evt => projet.mousemoveInZoomBox(canvaszoom, evt));
			canvaszoom.addEventListener('touchmove', evt => projet.mousemoveInZoomBox(canvaszoom, evt));

			canvaszoom.addEventListener('mouseup', evt => projet.mouseupInZoomBox(canvaszoom, evt));
			canvaszoom.addEventListener('touchend', evt => projet.mouseupInZoomBox(canvaszoom, evt));

			canvaszoom.addEventListener('mouseout', evt => leaveBox(canvas, evt, 'projet.mouseoutInZoomBox'));
			canvaszoom.addEventListener('mouseover', evt => leaveBox(canvas, evt, 'projet.mouseoverInZoomBox'));
		}
	}

	for (let varId in this.variables) {
		const v = this.variables[varId];
		if (v.environnement == false) continue;

		document.querySelector('#closebuttonvar_' + varId).addEventListener('click', function () {
			projet.toggleVar(varId);
		});
		document.querySelector('#varValue_' + varId).addEventListener('change', function () {
			const elem = document.querySelector('#varValue_' + varId);
			projet.changeEtatVariable(elem.selectedOptions[0].getAttribute('data-varid'), elem.value);
		});

		const elem = document.querySelector('#var_' + varId);
		elem.addEventListener('mousedown', function () {
			projet.switchZIndex(elem);
		});

		elem.addEventListener('touchstart', function () {
			projet.switchZIndex(elem);
		});
	}
};

projet.switchZIndex = function (element) {
	let elements = document.querySelectorAll('.window');
	let maxzindex = 1 + elements.length;
	element.style.zIndex = maxzindex + 1;
	elements.forEach(elem => {
		let zind = elem.style.zIndex;
		if (zind > 2) elem.style.zIndex = zind - 1;
	});
};

//......................................................................................................
//______________________________________________________________________________________________________
//
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// Retourne l'identidiant de la zone active dans laquelle la souris se trouve si elle se trouve fdans une zone active
//___________________________________________________
projet.getZoneUnderMouse = function (mouse, zoneType) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.getZoneUnderMouse';
	var zRetour = '';
	for (var zon in this.zones) {
		var z = this.zones[zon];
		switch (z.type) {
			case 'rotation':
				if (zoneType == 'MainBox' && isMouseBetweenCircles(mouse, z.xCentre, z.yCentre, z.rayonExterne, z.rayonInterne)) zRetour = zon;
				if (zoneType == 'ZoomBox' && isMouseBetweenCircles(mouse, z.zoom.xCentreImageRatio, z.zoom.yCentreImageRatio, z.rayonExterne * z.zoom.ratio, z.rayonInterne * z.zoom.ratio)) {
					zRetour = zon;
				}
				break;
			case 'bgImage':
			case 'reactive':
			case 'horizontal':
			case 'vertical':
			case 'bouton':
			case 'branchement':
			case 'stockage':
				if (zoneType == 'MainBox' && isMouseInRectangle(mouse, z.x, z.y, z.largeur, z.hauteur)) zRetour = zon;
				break;
			case 'autre.....':
				break;
		}
	}
	log(currentFunctionName, '(mouse=(' + mouse.x + ',' + mouse.y + '), zoneType=' + zoneType + ')' + ' ==> ' + zRetour);
	return zRetour;
};

//___________________________________________________
// Change la valeur d'une variable du projet => réaffichage du TP
//___________________________________________________
projet.changeEtatVariable = function (varId, value) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.changeEtatVariable';
	// vérification que les paramèters sont valides
	log(currentFunctionName, '(varId=' + varId + ', value=' + value + ')');
	if (this.variables[varId] != null && this.variables[varId].contenus[value] != null) {
		this.variables[varId].valeur = value;
		this.afficheImages();
	}
};

//___________________________________________________
// Passe à la valeur précédente d'une variable
//___________________________________________________
projet.getPreviousValue = function (varId) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.getPreviousValue';
	// vérification que les paramèters sont valides
	if (this.variables[varId] != null) {
		var indice = this.variables[varId].valeur.substring(1); //Tronque le "c" correspondantà l'id du contenu d'une variable dans la définition du TP
		indice = Math.max(1, parseInt(indice) - 1);
		this.changeEtatVariable(varId, 'c' + indice);
		log(currentFunctionName, '(varId=' + varId + ') , valeur=c' + indice);
	}
};

//___________________________________________________
// Passe à la valeur suivante d'une variable
//___________________________________________________
projet.getNextValue = function (varId) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.getNextValue';
	// vérification que les paramèters sont valides
	if (this.variables[varId] != null) {
		var indice = this.variables[varId].valeur.substring(1); //Tronque le "c" correspondantà l'id du contenu d'une variable dans la définition du TP
		indice = Math.min(parseInt(indice) + 1, taille(this.variables[varId].contenus));
		this.changeEtatVariable(varId, 'c' + indice);
		log(currentFunctionName, '(varId=' + varId + ') , valeur=c' + indice);
	}
};

//___________________________________________________
// Retourne l'identidiant de l'image par défaut (au démarrage) de l'application
//___________________________________________________
projet.getDefaultImageId = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.getDefaultImageId';
	var txt = '';
	for (var v in this.variables) {
		txt = txt + v + this.variables[v].defaut;
	}
	log(currentFunctionName, '() [association=' + txt + '] ==>' + this.associations[txt]);
	return this.associations[txt];
};

//___________________________________________________
// Retourne l'identidiant de l'image courante de la zonne passée en paramètre
//___________________________________________________
projet.getCurrentImageId = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.getCurrentImageId';
	var z = this.zones[zon];
	var txt = '';
	for (var v in this.variables) {
		if (z.dependances[v] == true) txt = txt + v + this.variables[v].valeur;
		else txt = txt + v + this.variables[v].defaut;
	}
	if (txt != '') {
		z.imageCourante = this.associations[txt];
	} else {
		z.imageCourante = this.getDefaultImageId();
	}
	log(currentFunctionName, '(zon=' + zon + ') [association=' + txt + '] ==>' + z.imageCourante);
	return z.imageCourante;
};

//......................................................................................................
//______________________________________________________________________________________________________
// Partie Affichage :  Cette partie contient les méthodes d'affichage du player
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// Matérialise les zones actives (qui réagissent à la souris ou au doigt) quand projet.voirZones vaut true
//___________________________________________________
projet.drawZonesActives = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.drawZonesActives';
	log(currentFunctionName, '()');
	let borderColor = 'rgb(86,110,213)';
	if (this.couleurZones.red) borderColor = 'rgb(' + this.couleurZones.red + ',' + this.couleurZones.green + ',' + this.couleurZones.blue + ')';

	if (this.voirZones) {
		//var context = canvas.getContext('2d');
		for (var zon in this.zones) {
			var z = this.zones[zon];
			switch (z.type) {
				case 'bgImage':
					break;
				case 'rotation':
					if (this.couleurZones.actives) borderColor = 'rgb(' + this.couleurZones.actives.red + ',' + this.couleurZones.actives.green + ',' + this.couleurZones.actives.blue + ')';
					var r = z.rayonExterne - 1;
					drawCircle(this.context, z.xCentre, z.yCentre, r, borderColor, 1);
					drawCircle(this.context, z.xCentre, z.yCentre, z.rayonInterne, borderColor, 1);
					if (z.zoom.autorise && z.zoom.visible) {
						drawCircle(z.zoom.context, z.zoom.xCentreImage, z.zoom.yCentreImage, r, borderColor, 1);
						drawCircle(z.zoom.context, z.zoom.xCentreImage, z.zoom.yCentreImage, z.rayonInterne, borderColor, 1);
					}
					break;
				case 'reactive':
					if (this.couleurZones.reactives) borderColor = 'rgb(' + this.couleurZones.reactives.red + ',' + this.couleurZones.reactives.green + ',' + this.couleurZones.reactives.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					if (z.zoom.autorise && z.zoom.visible) {
						drawRect(z.zoom.context, z.zoom.xImage + 1, z.zoom.yImage + 1, z.largeur - 2, z.hauteur - 2, borderColor, 1);
					}
					break;
				case 'horizontal':
					if (this.couleurZones.actives) borderColor = 'rgb(' + this.couleurZones.actives.red + ',' + this.couleurZones.actives.green + ',' + this.couleurZones.actives.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					if (z.zoom.autorise && z.zoom.visible) {
						drawRect(z.zoom.context, z.zoom.xImage + 1, z.zoom.yImage + 1, z.largeur - 2, z.hauteur - 2, borderColor, 1);
					}
					break;
				case 'vertical':
					if (this.couleurZones.actives) borderColor = 'rgb(' + this.couleurZones.actives.red + ',' + this.couleurZones.actives.green + ',' + this.couleurZones.actives.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					if (z.zoom.autorise && z.zoom.visible) {
						drawRect(z.zoom.context, z.zoom.xImage + 1, z.zoom.yImage + 1, z.largeur - 2, z.hauteur - 2, borderColor, 1);
					}
					break;
				case 'bouton':
					if (this.couleurZones.boutons) borderColor = 'rgb(' + this.couleurZones.boutons.red + ',' + this.couleurZones.boutons.green + ',' + this.couleurZones.boutons.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					break;
				case 'branchement':
					if (this.couleurZones.branchements) borderColor = 'rgb(' + this.couleurZones.branchements.red + ',' + this.couleurZones.branchements.green + ',' + this.couleurZones.branchements.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					break;
				case 'stockage':
					if (this.couleurZones.stockage) borderColor = 'rgb(' + this.couleurZones.stockage.red + ',' + this.couleurZones.stockage.green + ',' + this.couleurZones.stockage.blue + ')';
					drawRect(this.context, z.x + 1, z.y + 1, z.largeur - 2, z.hauteur - 2, borderColor, 2);
					break;
				case 'autre.....':
					break;
			}
		}
	}
};

//___________________________________________________
// Affiche l'image correspondant à l'id passé en paramàtre dans la zone passée en paramètre
//___________________________________________________
projet.afficheImage = function (id, zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.afficheImage';
	var z = this.zones[zon];
	z.imageCourante = id;
	this.adjustButtonStyle(zon);
	log(currentFunctionName, '(id = ' + id + ', zon = ' + zon + ') : [ ratio = ' + z.zoom.ratio + ']');
	var img = z.images[id];
	log(currentFunctionName, '(id = ' + id + ', zon = ' + zon + ') : [ img = ' + img + ' context = ' + this.context + ']');
	// Affichage l'image sur la fenetre principale
	if (img != undefined) {
		//N'afficher que si l'image existe
		this.context.drawImage(img, z.x, z.y, z.largeur, z.hauteur);
		log(currentFunctionName, '(id = ' + id + ', zon = ' + zon + ') : [ z.x = ' + z.x + ' z.y = ' + z.y + ' z.largeur = ' + z.largeur + ' z.hauteur = ' + z.hauteur + ']');
	}
	// Affichage  si besoin l'image sur la fenetre de zoom
	if (z.zoom.autorise && z.zoom.visible) {
		if (z.zoom.canvas == 'undefined') z.zoom.canvas = document.getElementById('canvaszoom' + zon);
		if (z.zoom.context == 'undefined') {
			z.zoom.context = z.zoom.canvas.getContext('2d');
			z.zoom.context.scale(z.zoom.ratio, z.zoom.ratio);
		}
		img = z.zoom.images[id];
		if (img != undefined) {
			//N'afficher que si l'image existe
			z.zoom.context.fillStyle = '#FFFFFF';
			z.zoom.context.fillRect(0, 0, z.zoom.canvas.width, z.zoom.canvas.height);
			z.zoom.context.drawImage(img, z.zoom.xImage, z.zoom.yImage, z.largeur, z.hauteur);
		}
	}
	// Affichage des boutons zooms +/-, et les flèches de déplacement sur la fenetre de zoom de la zone en cours
	if (z.zoom.autorise && z.zoom.visible && z.zoom.actif) {
		var ratio = z.zoom.ratio;
		var zAction = z.zoom.actions['up'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
		zAction = z.zoom.actions['left'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
		zAction = z.zoom.actions['right'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
		zAction = z.zoom.actions['down'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
		zAction = z.zoom.actions['zoomplus'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
		zAction = z.zoom.actions['zoommoins'];
		z.zoom.context.drawImage(zAction.image, zAction.x / ratio, zAction.y / ratio, zAction.largeur / ratio, zAction.hauteur / ratio);
	}
	// Matérialise les zones réactives à la souris ou au doigt
	this.drawZonesActives();
};

//___________________________________________________
//Génère une chaine de caractère de la forme : 'nomDeVariable=valeur|nomDeVariable=valeur...'
//et ajoute cette chaine dans une variable de session du navigateur via la fonction "sessionStorage.setItem"
// objectif : permettre de récupérer cette info dans une page web pour traitement (aiguillage conditionnel, Topaze)
// 4 varialbes sonts stockées : semmlabs_titre,semmlabs_variables,semmlabs_idimagecourante,semmlabs_nomimagecourante
//___________________________________________________
projet.setSessionStorage = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.setSessionStorage';
	log(currentFunctionName, '()');
	var txtvar = '';
	var txt = '';
	for (var v in this.variables) {
		var val = this.variables[v].valeur;
		txtvar = txtvar + v + ':' + val + '=' + this.variables[v].titre + ':' + this.variables[v].contenus[val] + ';';
		txt = txt + v + val;
	}
	sessionStorage.setItem('semmlabs_titre', this.titre);
	sessionStorage.setItem('semmlabs_variables', txtvar);
	sessionStorage.setItem('semmlabs_idimagecourante', txt);
	sessionStorage.setItem('semmlabs_nomimagecourante', this.imageIds[this.associations[txt]]);
	sessionStorage.setItem('semmlabs_refresh', 'false');
};

//___________________________________________________
//Recharge l'application dans l'état des vartiables stockées dans le sessionstorage
//objectif : permettre de revenir sur l'animation après traitement dans une page externe (aiguillage conditionnel, Topaze)
// Condition : avoir une variable de session semmlabs_reload=true et les 4 variables du getSessionStorage renseignées
//___________________________________________________
projet.getSessionStorage = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.setSessionStorage';
	log(currentFunctionName, '()');
	var tit = sessionStorage.getItem('semmlabs_titre');
	var refresh = sessionStorage.getItem('semmlabs_refresh');
	if (tit == this.titre && refresh == 'true') {
		var txtvar = sessionStorage.getItem('semmlabs_variables');
		var res = txtvar.split(';');
		for (t in res) {
			var res2 = res[t].split('=');
			var res3 = res2[0].split(':');
			this.changeEtatVariable(res3[0], res3[1]);
		}
	}
};

//___________________________________________________
//Affiche les images courantes de chaque zone
//___________________________________________________
projet.afficheImages = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.afficheImages';
	log(currentFunctionName, '()');
	for (var zon in this.zones) {
		var z = this.zones[zon];
		if (z.zoom.actions['up'] == null) {
			projet.initZoomBoxActions(zon);
		}
		this.afficheImage(this.getCurrentImageId(zon), zon);
	}
	this.setSessionStorage();
};

//......................................................................................................
//______________________________________________________________________________________________________
// Partie Initialisation :  Cette partie contient les méthodes d'instentiation du player
//______________________________________________________________________________________________________
//......................................................................................................

//___________________________________________________
// Toute la phase d'initialisation du projet passe par cette méthode
//___________________________________________________
projet.init = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	this.indentation = 0;
	var currentFunctionName = 'projet.init';
	document.querySelector('#MainTitle').innerHTML = this.titre;
	document.querySelector('#version').innerHTML = 'v' + version;
	if (!VersionCompare.matches(this.version, file_version)) {
		alert('Semmlabs Player v' + version + ' est compatible avec les TP numériques en version v' + file_version + '. Le TP que vous souhaitez ouvrir est de version v' + this.version + '. Certaines actions risquent de ne pas fonctionner correctement.');
	}
	// Gestion de l'affichage de l'entrée de menu "Debug"
	if (!debug) {
		document.querySelector('#mnuMainDebug').classList.toggle('off');
	}
	this.initMenuEnvironement();
	//Redimensionne le canvas principal
	this.canvas = document.getElementById('mainCanvas');
	this.canvas.height = this.dimensionScene.hauteur;
	this.canvas.width = this.dimensionScene.largeur;
	log(currentFunctionName, '() [hauteurScene = ' + this.dimensionScene.hauteur + ', largeurScene = ' + this.dimensionScene.largeur + ']');
	this.context = this.canvas.getContext('2d');
	//Ajoute les actions souris au canvas principal

	//Initialise les différentes zones
	for (var zon in this.zones) {
		this.initZoomBox(zon);

		var z = this.zones[zon];
		switch (z.type) {
			case 'rotation':
				z.rayonExterne = Math.min(z.largeur / 2, z.hauteur / 2);
				z.xCentre = z.x + z.largeur / 2;
				z.yCentre = z.y + z.hauteur / 2;
				this.recalculeCentreZoom(zon);
				break;
			case 'bgImage':
			case 'horizontal':
			case 'vertical':
			case 'reactive':
			case 'autre.....':
				break;
		}
	}

	for (let zon in this.zones) {
		if (this.zones[zon].zoom.autorise == false) continue;
		document.querySelector('#zoombutton' + zon).addEventListener('click', function () {
			projet.toggleZoomSliders(zon);
		});
		document.querySelector('#closebutton' + zon).addEventListener('click', function () {
			projet.toggleZoom(zon);
		});

		const elem = document.querySelector('#' + this.zones[zon].zoom.id);
		elem.addEventListener('mousedown', function () {
			projet.switchZIndex(elem);
		});

		elem.addEventListener('touchstart', function () {
			projet.switchZIndex(elem);
		});

		projet.initZoomBoxActions(zon);
		projet.resizeZoomBox(zon);
	}

	this.addListeners();
	this.getSessionStorage();
};

//___________________________________________________
//Permet de recalculer les coordonnées du centre de la zone de soom après les redimensionnements
//___________________________________________________
projet.recalculeCentreZoom = function (zon) {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.recalculeCentreZoom';
	var z = this.zones[zon];
	z.zoom.xCentreImage = z.zoom.xImage + z.largeur / 2;
	z.zoom.yCentreImage = z.zoom.yImage + z.hauteur / 2;
	z.zoom.xCentreImageRatio = z.zoom.xCentreImage * z.zoom.ratio;
	z.zoom.yCentreImageRatio = z.zoom.yCentreImage * z.zoom.ratio;
	log(currentFunctionName, '() [zone.zoom.xCentreImage = ' + z.zoom.xCentreImage + ', zone.zoom.yCentreImage = ' + z.zoom.yCentreImage + 'zone.zoom.xCentreImageRatio = ' + z.zoom.xCentreImageRatio + ', zone.zoom.yCentreImageRatio = ' + z.zoom.yCentreImageRatio + ']');
};

//___________________________________________________
//Initialise le contenu du menu "Environnement" qui permet de changer l'état d'une variable d'environnement
//___________________________________________________
projet.initMenuEnvironement = function () {
	this.rien = 0; //variable inutile servant à palier un probleme d'affichage dans la outline d'Eclipse
	var currentFunctionName = 'projet.initMenuEnvironement';
	var hideMenu = true;
	for (var vname in this.variables) {
		var v = this.variables[vname];
		if (v.environnement == true) {
			hideMenu = false;
			this.initEnvBox(vname);
		}
	}

	if (hideMenu) {
		document.querySelector('#mnuMainEnv').classList.toggle('off');
	}
	log(currentFunctionName, '() [hideMenu = ' + hideMenu + ']');
};

projet.about = function () {
	const nl = String.fromCharCode(13);
	alert(`Semmlabs Player version v${version}${nl}Réalisation 2015${nl}SEMM - Université de Lille Sciences et Technologies avec le soutien de l'UNT Unisciel${nl}Contact : franck.rouze@univ-lille1.fr`);
};
