//semmlabsPlayer's version
var version = '2.0.0';
//semmlabs file's version
var file_version = '2.0.0';

var debug = false;
var show_debug_div = false;
var Id_Timer = null;
var mousedrag = false;
var oldMouse = { x: 0, y: 0 };
var currentZone = '';
var currentDragZone = '';
var showLog = {
	'projet.addListeners': true,
	'projet.adjustButtonStyle': true,
	'projet.afficheImage': true,
	'projet.afficheImages': true,
	'projet.changeEtatVariable': true,
	'projet.drawZonesActives': true,
	'projet.garbageImages': false,
	'projet.getCurrentImageId': true,
	'projet.getDefaultImageId': true,
	'projet.getNextValue': true,
	'projet.getPreviousValue': true,
	'projet.getSessionStorage': false,
	'projet.getZoneUnderMouse': true,
	'projet.imageCount': true,
	'projet.init': true,
	'projet.initEnvBox': true,
	'projet.initMenuEnvironement': true,
	'projet.initProgressBar': true,
	'projet.initZoomBox': false,
	'projet.initZoomBoxAction': false,
	'projet.initZoomBoxActions': false,
	'projet.isActive': false,
	'projet.isReactive': false,
	'projet.loadIcon': false,
	'projet.loadIcons': false,
	'projet.loadImages': false,
	'projet.mousedownInMainBox': false,
	'projet.mousedownInZoomBox': false,
	'projet.mousemoveInMainBox': false,
	'projet.mousemoveInZoomBox': false,
	'projet.mouseoutInMainBox': false,
	'projet.mouseoverInMainBox': false,
	'projet.mouseupInMainBox': false,
	'projet.mouseupInZoomBox': false,
	'projet.moveAction': false,
	'projet.recalculeCentreZoom': true,
	'projet.resizeZoomBox': true,
	'projet.rienFaire': true,
	'projet.scrollBas': true,
	'projet.scrollDroite': true,
	'projet.scrollGauche': true,
	'projet.scrollHaut': true,
	'projet.setBoutonOnOff': false,
	'projet.setButtonOnOff': false,
	'projet.setSessionStorage': false,
	'projet.startAction': true,
	'projet.startScroll': true,
	'projet.startZoom': true,
	'projet.stopAction': true,
	'projet.stopScroll': true,
	'projet.stopZoom': true,
	'projet.switchCSS': true,
	'projet.toggleViewZones': true,
	'projet.toggleZoom': true,
	'projet.toggleZoomSliders': true,
	'projet.zoomIn': true,
	'projet.zoomOut': true,
};
//_________________________________________________
// retourne la taille d'un tableau associatif
//_________________________________________________
function taille(dictionnary) {
	var n = 0;
	for (var elt in dictionnary) n++;
	return n;
}

//_________________________________________________
// Change l'état de la fenetre de debug
//_________________________________________________
function toggleShowDebugDiv() {
	document.querySelector('#mnuShowDebugDiv').classList.toggle('on');
	document.querySelector('#mnuShowDebugDiv').classList.toggle('off');
	document.querySelector('#debug').classList.toggle('hide');
}

//_________________________________________________
// Initialise la fenetre de debug
//_________________________________________________
function initDebug() {
	// console.log(document.querySelector('#debug').size);
	// document.querySelector('#debug').offsetWidth += document.querySelector('#debug_content').offsetWidth + 5;
	// console.log(document.querySelector('#debug_content').offsetWidth);

	interact('#debug')
		.resizable({
			edges: { left: true, right: true, bottom: true, top: false },
			listeners: {
				move(event) {
					var target = event.target;
					var x = parseFloat(target.getAttribute('data-x')) || 0;
					var y = parseFloat(target.getAttribute('data-y')) || 0;

					// update the element's style
					target.style.width = event.rect.width + 'px';
					target.style.height = event.rect.height + 'px';

					// translate when resizing from top or left edges
					x += event.deltaRect.left;
					y += event.deltaRect.top;

					target.style.webkitTransform = target.style.transform = 'translate(' + x + 'px,' + y + 'px)';

					target.setAttribute('data-x', x);
					target.setAttribute('data-y', y);
					document.querySelector('#debug_content').style.width = event.rect.width - 10 + 'px';
					document.querySelector('#debug_content').style.height = event.rect.height - 40 + 'px';
				},
			},
			modifiers: [
				interact.modifiers.restrictEdges({
					outer: 'parent',
				}),

				// minimum size
				interact.modifiers.restrictSize({
					min: { width: 125, height: 150 },
				}),
			],

			inertia: true,
		})
		.draggable({
			allowFrom: '.header',
			listeners: { move: window.dragMoveListener },
			inertia: true,
			modifiers: [
				interact.modifiers.restrictRect({
					restriction: '#mainContaint',
					endOnly: true,
				}),
			],
		});

	const mnuShowDebugDiv = document.querySelector('#mnuShowDebugDiv');
	if (show_debug_div) {
		mnuShowDebugDiv.classList.add('on');
		mnuShowDebugDiv.classList.remove('off');
		document.querySelector('#debug').classList.remove('hide');
	} else {
		mnuShowDebugDiv.classList.remove('on');
		mnuShowDebugDiv.classList.add('off');
		document.querySelector('#debug').classList.add('hide');
	}
}
function clearDebug() {
	if (debug) {
		document.querySelector('#debug_content').value = ' ';
		console.clear();
	}
}

//_________________________________________________
// Affiche un message dans la console Javascript
//_________________________________________________
function log(functionName, message) {
	const debug_content = document.querySelector('#debug_content');
	if (debug) {
		if (message == null) {
			console.log(functionName);
			debug_content.value += `\n${functionName}`;
		} else if (showLog[functionName]) {
			console.log(functionName + message);
			debug_content.value += `\n${functionName}${message}`;
		}
	}
}

//__________________________________________________________________________________________________
// Manipulation de la souris
//__________________________________________________________________________________________________

//_________________________________________________
// retourne les coordonnées (x,y) de la souris dans le cancas
//_________________________________________________
function getMouseLocation(canvas, evt) {
	var rect = canvas.getBoundingClientRect();
	return {
		x: evt.clientX - rect.left,
		y: evt.clientY - rect.top,
	};
}
function getTouchLocation(canvas, evt) {
	var rect = canvas.getBoundingClientRect();
	return {
		x: evt.changedTouches[0].pageX - rect.left,
		y: evt.changedTouches[0].pageY - rect.top,
	};
}

function isMouseInRectangle(mouse, x, y, width, height) {
	return mouse.x > x && mouse.x < x + width && mouse.y > y && mouse.y < y + height;
}
function isMouseInCircle(mouse, xcenter, ycenter, ray) {
	return Math.pow(xcenter - mouse.x, 2) + Math.pow(ycenter - mouse.y, 2) < Math.pow(ray, 2);
}
function isMouseBetweenCircles(mouse, xcenter, ycenter, rayExt, rayInt) {
	return isMouseInCircle(mouse, xcenter, ycenter, rayExt) && !isMouseInCircle(mouse, xcenter, ycenter, rayInt);
}

//__________________________________________________________________________________________________
// affichages graphiques
//__________________________________________________________________________________________________

//_________________________________________________
// Trace un rectangle dans le context du canvas passé en paramètre
//_________________________________________________
function drawRect(context, left, top, width, height, lineColor, lineWidth) {
	context.beginPath();
	context.rect(left, top, width, height);
	//context.fillStyle = 'yellow';
	//context.fill();
	context.lineWidth = lineWidth;
	context.strokeStyle = lineColor;
	context.stroke();
}

//_________________________________________________
// Trace un cercle dans le context du canvas passé en paramètre
//_________________________________________________
function drawCircle(context, x, y, rayon, lineColor, lineWidth) {
	context.beginPath();
	context.arc(x, y, rayon, 0, 2 * Math.PI);
	//context.fillStyle = 'yellow';
	//context.fill();
	context.lineWidth = lineWidth;
	context.strokeStyle = lineColor;
	context.stroke();
	context.closePath();
}

//__________________________________________________________________________________________________
// Math
//__________________________________________________________________________________________________

//_________________________________________________
// Retourne l'angle BAC avec les 3 points A,B,C entrés en paramètre
//_________________________________________________
function calculAngle(xa, ya, xb, yb, xc, yc) {
	//calcul des vecteurs vAB et vAC
	var vAB = { x: xb - xa, y: yb - ya };
	var vAC = { x: xc - xa, y: yc - ya };
	// inversion des ordonnées des vecteurs à cause du système d'axes de l'écran (Y dirigé vers le bas)
	vAB.y = -vAB.y;
	vAC.y = -vAC.y;
	//calcul du produit scalaire vAB . vAC. Le produit scalaire vAB.vAC = norme(vAB)*norme(vAC)*cos(BAC)
	var pScal = vAB.x * vAC.x + vAB.y * vAC.y;
	//calcul du produit mixte vAB ^ vAC. Le produit mixte vAB^vAC = norme(vAB)*norme(vAC)*sin(BAC)
	var pMix = vAB.x * vAC.y - vAB.y * vAC.x;
	var nvAB = norme(vAB.x, vAB.y);
	var nvAC = norme(vAC.x, vAC.y);
	var pnorme = nvAB * nvAC;
	var cosTheta = pScal / pnorme;
	var sinTheta = pMix / pnorme;
	var theta = (Math.acos(cosTheta) * sinTheta) / Math.abs(sinTheta);
	//log('pscal= '+pScal+" pmix= "+pMix+" ||vAB||= "+nvAB+" ||vAC||= "+nvAC +" cos= "+cosTheta+" sin= "+sinTheta+" theta= "+theta);
	return theta;
}

//_________________________________________________
// convertit des radians en degrés
//_________________________________________________
function rad2deg(angle) {
	return (angle * 180) / Math.PI;
}

//_________________________________________________
// Retourne la norme du vecteur de coordonnées x,y
//_________________________________________________
function norme(x, y) {
	return Math.sqrt(x * x + y * y);
}

//_________________________________________________
// Si une des variable contient la valeur
// retourne {valeur, variable} ou null
//_________________________________________________
function allVarTripleContainsValue(value, lowerCase) {
	for (let vname in projet.variables) {
		let v = projet.variables[vname];
		for (let cname in v.contenus) {
			let c = v.contenus[cname];
			if (lowerCase) {
				c = c.toLowerCase();
				value = value.toLowerCase();
			}
			if (c.includes(value)) return { variable: vname, valeur: cname };
		}
	}
	return null;
}

//_________________________________________________
// Si la variable contient la valeur
// retourne {valeur} ou null
//_________________________________________________
function varTripleContainsValue(variable, value, lowerCase) {
	for (let cname in variable.contenus) {
		let c = variable.contenus[cname];
		if (lowerCase) {
			c = c.toLowerCase();
			value = value.toLowerCase();
		}
		if (c.includes(value)) {
			return cname;
		}
	}
	return null;
}
